Index: /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_cover.f90
===================================================================
--- /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_cover.f90	(revision 256)
+++ /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_cover.f90	(revision 257)
@@ -23,5 +23,5 @@
 
   SUBROUTINE cover (npts, cn_ind, ind, biomass, &
-       veget_max, veget_max_old, veget, lai, litter, carbon)
+       veget_max, veget_max_old, veget, lai, litter, carbon, turnover_daily, bm_to_litter)
 
     !
@@ -37,4 +37,5 @@
     ! density of individuals (1/(m**2 of ground))
     REAL(r_std), DIMENSION(npts,nvm), INTENT(in)          :: ind
+    ! "maximal" coverage fraction of a PFT (LAI -> infinity) on ground at beginning of time step
     REAL(r_std), DIMENSION(npts,nvm), INTENT(in)          :: veget_max_old
 
@@ -44,4 +45,8 @@
     ! "maximal" coverage fraction of a PFT (LAI -> infinity) on ground
     REAL(r_std), DIMENSION(npts,nvm), INTENT(inout)       :: veget_max
+    ! Turnover rates (gC/(m**2 of ground)/day)
+    REAL(r_std), DIMENSION(npts,nvm,nparts), INTENT(inout)          :: turnover_daily
+    ! conversion of biomass to litter (g/m**2 / day
+    REAL(r_std), DIMENSION(npts,nvm,nparts), INTENT(inout)          :: bm_to_litter
 
     ! 0.3 output
@@ -50,5 +55,5 @@
     REAL(r_std), DIMENSION(npts,nvm), INTENT(inout)       :: veget
     ! leaf area index OF AN INDIVIDUAL PLANT
-    REAL(r_std), DIMENSION(npts,nvm), INTENT(in)         :: lai
+    REAL(r_std), DIMENSION(npts,nvm), INTENT(inout)         :: lai
 
     ! metabolic and structural litter, above and below ground (gC/(m**2 of ground))
@@ -60,5 +65,5 @@
 
     ! index
-    INTEGER(i_std)                                         :: i,j
+    INTEGER(i_std)                                         :: i,j,k,m
 
     ! Litter dilution (gC/mÂ²)
@@ -68,7 +73,9 @@
 
     ! conversion vectors
-    REAL(r_std),DIMENSION(nvm)                                         :: delta_veg
+    REAL(r_std),DIMENSION(nvm)                                         :: delta_veg,reduct
     ! vecteur de conversion
-    REAL(r_std)                                                        :: delta_veg_sum
+    REAL(r_std)                                                        :: delta_veg_sum,diff,sr
+    REAL(r_std), DIMENSION(npts)                                       :: frac_nat,sum_vegettree,sum_vegetgrass
+    REAL(r_std), DIMENSION(npts)                                       :: sum_veget_natveg
 
     ! =========================================================================
@@ -81,5 +88,11 @@
     IF ( control%ok_dgvm ) THEN
 
-       veget_max(:,ibare_sechiba) = 1.
+       ! some initialisations
+       frac_nat(:) = un
+       sum_veget_natveg(:) = zero
+       sum_vegettree(:) = zero
+       sum_vegetgrass(:) = zero
+
+       veget_max(:,ibare_sechiba) = un
 
        DO j = 2,nvm
@@ -88,49 +101,78 @@
 
              veget_max(:,j) = ind(:,j) * cn_ind(:,j)
-
-          ENDIF
-
+             sum_veget_natveg(:) = sum_veget_natveg(:) + veget_max(:,j)
+
+          ELSE
+             !fraction occupied by agriculture needs to be substracted for the DGVM
+             !this is used below to constrain veget for natural vegetation, see below
+             frac_nat(:) = frac_nat(:) - veget_max(:,j)
+
+          ENDIF
+
+       ENDDO
+
+       DO i = 1, npts 
+
+          IF (sum_veget_natveg(i) .GT. frac_nat(i) .AND. frac_nat(i) .GT. min_stomate) THEN
+
+             DO j = 2,nvm
+                IF( natural(j) ) THEN
+                   veget_max(i,j) =  veget_max(i,j) * frac_nat(i) / sum_veget_natveg(i)
+                ENDIF
+             ENDDO
+
+          ENDIF
+       ENDDO
+
+       DO j = 2,nvm
           veget_max(:,ibare_sechiba) = veget_max(:,ibare_sechiba) - veget_max(:,j)
-
-       ENDDO
-
+       ENDDO
        veget_max(:,ibare_sechiba) = MAX( veget_max(:,ibare_sechiba), zero )
 
+       ! 1.3 calculate carbon fluxes between PFTs to maintain mass balance
+       !
+
+       DO i = 1, npts         
+          ! Generation of the conversion vector
+
+          delta_veg(:) = veget_max(i,:)-veget_max_old(i,:)
+          delta_veg_sum = SUM(delta_veg,MASK=delta_veg.LT.zero)
+
+          dilu_lit(i,:,:) = zero
+          dilu_soil_carbon(i,:) = zero
+          DO j=1, nvm
+             IF ( delta_veg(j) < -min_stomate ) THEN 
+                dilu_lit(i,:,:)=  dilu_lit(i,:,:) + delta_veg(j)*litter(i,:,j,:) / delta_veg_sum
+                dilu_soil_carbon(i,:)=  dilu_soil_carbon(i,:) + delta_veg(j) * carbon(i,:,j) / delta_veg_sum
+             ENDIF
+          ENDDO
+
+          DO j=1, nvm
+             IF ( delta_veg(j) > min_stomate) THEN
+
+                ! Dilution of reservoirs
+
+                ! Litter
+                litter(i,:,j,:)=(litter(i,:,j,:) * veget_max_old(i,j) + dilu_lit(i,:,:) * delta_veg(j)) / veget_max(i,j)
+
+                ! Soil carbon
+                carbon(i,:,j)=(carbon(i,:,j) * veget_max_old(i,j) + dilu_soil_carbon(i,:) * delta_veg(j)) / veget_max(i,j)
+
+             ENDIF
+
+             IF(j.GE.2.AND.veget_max_old(i,j).GT.min_stomate.AND.veget_max(i,j).GT.min_stomate) THEN
+
+                ! Correct biomass densities (i.e. also litter fall) to conserve mass 
+                ! since it's defined on veget_max
+
+                biomass(i,j,:)=biomass(i,j,:)*veget_max_old(i,j)/veget_max(i,j)
+                turnover_daily(i,j,:)=turnover_daily(i,j,:)*veget_max_old(i,j)/veget_max(i,j)
+                bm_to_litter(i,j,:)=bm_to_litter(i,j,:)*veget_max_old(i,j)/veget_max(i,j)
+
+             ENDIF
+
+          ENDDO
+       ENDDO
     ENDIF
-
-    DO i = 1, npts         
-       ! Generation of the conversion vector
-
-       delta_veg(:) = veget_max(i,:)-veget_max_old(i,:)
-       delta_veg_sum = SUM(delta_veg,MASK=delta_veg.LT.zero)
-
-       dilu_lit(i,:,:) = zero
-       dilu_soil_carbon(i,:) = zero
-       DO j=1, nvm
-          IF ( delta_veg(j) < -min_stomate ) THEN 
-             dilu_lit(i,:,:)=  dilu_lit(i,:,:) - delta_veg(j)*litter(i,:,j,:) / delta_veg_sum
-             dilu_soil_carbon(i,:)=  dilu_soil_carbon(i,:) - delta_veg(j) * carbon(i,:,j) / delta_veg_sum
-          ENDIF
-       ENDDO
-
-       DO j=1, nvm
-          IF ( delta_veg(j) > min_stomate) THEN
-
-             ! Dilution of reservoirs
-
-             ! Litter
-             litter(i,:,j,:)=(litter(i,:,j,:) * veget_max_old(i,j) + dilu_lit(i,:,:) * delta_veg(j)) / veget_max(i,j)
-
-             ! Soil carbon
-             carbon(i,:,j)=(carbon(i,:,j) * veget_max_old(i,j) + dilu_soil_carbon(i,:) * delta_veg(j)) / veget_max(i,j)
-
-          ENDIF
-          !SZ correct biomass to conserve mass since it's defined on veget_max
-          IF(j.GE.2.AND.veget_max_old(i,j).GT.min_stomate.AND.veget_max(i,j).GT.min_stomate) THEN
-             biomass(i,j,:)=biomass(i,j,:)*veget_max_old(i,j)/veget_max(i,j)
-          ENDIF
-
-       ENDDO
-    ENDDO
 
     !
@@ -140,4 +182,6 @@
     !
     !MM in Soenke code but not in merge version ; must keep that ??
+!NV, MM : we keep those comments for compatibility with CMIP5 computations.
+!! They have to be uncommented avec CMIP5 versions in the trunk !
 !!$    DO j = 2,nvm
 !!$       lai(:,j) = biomass(:,j,ileaf,icarbon)*sla(j)
@@ -153,9 +197,97 @@
              veget(i,j) = veget_max(i,j)
           ELSE
-             veget(i,j) = veget_max(i,j) * ( 1. - exp( - lai(i,j) * ext_coeff(j) ) )
+             IF ( control%ok_dgvm ) THEN
+!!$SZneed to check this - this formulation will cause 100% veget, otherwise there will always 
+!!$ be some percent bare ground
+                veget(i,j) = ind(i,j) * cn_ind(i,j)  * ( un - EXP( - lai(i,j) * ext_coeff(j) ) )
+             ELSE
+                veget(i,j) = veget_max(i,j) * ( un - EXP( - lai(i,j) * ext_coeff(j) ) )
+             ENDIF
+          ENDIF
+
+          ! check sums of fpc for natural vegetation (see correction below!) in dynamic mode
+          IF ( control%ok_dgvm ) THEN
+
+             IF(natural(j))THEN
+                IF(tree(j)) THEN
+                   sum_vegettree(i)=sum_vegettree(i)+veget(i,j)
+                ELSE 
+                   sum_vegetgrass(i)=sum_vegetgrass(i)+veget(i,j)
+                ENDIF
+             ENDIF
+
           ENDIF
        ENDDO
     ENDDO
-    !
+
+
+    ! 3.1 correct gridscale fpc for dynamic vegetation
+!!$SZ, this part should be obsolete now that veget_max is forced to 1.0
+!!$ nevertheless maintained just for savety. Whoever wants to test
+!!$ whether this works without is invited to do so.
+
+    ! in the DGVM mode, we can arrive at a sum of veget slighly exceeding 1.0,
+    ! because mainly of grass dynamics...
+    ! In this case, we devide the fpar over natural vegetation first such that 
+    ! grasses are shadowed by trees, and in the theoretically impossible case that
+    ! this is not sufficient, reduce proportionally all veget's.
+    !
+    IF ( control%ok_dgvm ) THEN
+
+       DO i = 1,npts
+
+          diff=sum_vegettree(i)+sum_vegetgrass(i)-frac_nat(i)
+          reduct(:) = 0.
+          ! ordinary case, the reason too much grasses 
+          ! reduce grass veget to match the maximum
+          IF (diff .GT. 0. ) THEN
+
+             IF (sum_vegetgrass(i).GT.min_stomate) THEN
+                sr=0.
+                DO j=2,nvm
+                   IF(natural(j).AND..NOT.tree(j)) THEN
+                      reduct(j)=-MIN(diff,sum_vegetgrass(i))*veget(i,j)/sum_vegetgrass(i)
+                      sr=sr+reduct(j)
+                   ENDIF
+                ENDDO
+                diff=diff+sr
+             ENDIF
+
+          ENDIF
+
+          ! this is theoretically impossible, since trees can only occupy 95%,
+          ! but better be save than sorry
+          IF (diff .GT. min_stomate ) THEN
+
+             IF (sum_vegettree(i).GT.min_stomate) THEN
+                sr=0.
+                DO j=2,nvm
+                   IF(natural(j).AND.tree(j)) THEN
+                      reduct(j)=-MIN(diff,sum_vegettree(i))*veget(i,j)/sum_vegettree(i)
+                      sr=sr+reduct(j)
+                   ENDIF
+                ENDDO
+                diff=diff+sr 
+             ENDIF
+
+          ENDIF
+
+!!$          ! tell user if the problem could not be resolved
+!!$          ! in theory the model should stop here!
+!!$          IF (diff .GT. min_stomate ) THEN
+!!$
+!!$             write(numout,*) 'ATT, DGVM!: veget exceeds bareground without vegetation left'
+!!$             write(numout,*) 'ATT, DGVM!: is this a bug? cell: ',i
+!!$             write(numout,*) 'ATT, DGVM!: veget ',veget(i,:)
+!!$
+!!$          ENDIF
+
+          ! finally, implement the reduction. (reduc is negative!)
+          veget(i,:)=veget(i,:)+reduct(:)
+
+       ENDDO
+
+    ENDIF
+
     veget(:,ibare_sechiba) = un
     DO j = 2,nvm
Index: /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_crown.f90
===================================================================
--- /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_crown.f90	(revision 256)
+++ /branches/ORCHIDEE_EXT/ORCHIDEE/src_stomate/lpj_crown.f90	(revision 257)
@@ -6,4 +6,8 @@
   !---------------------------------------------------------------------
   !- calculate individual crown area from stem mass.
+  !- SZ, I've put the woodmass calculation out of this routine
+  !      because after the very first establishment, woodmass
+  !      could not be calculated here as veget_max = zero and 
+  !      d_ind not known...
   !---------------------------------------------------------------------
   USE ioipsl
@@ -24,5 +28,5 @@
   !-
   SUBROUTINE crown &
-       &  (npts, PFTpresent, ind, biomass, veget_max, cn_ind, height)
+       &  (npts, PFTpresent, ind, biomass, woodmass_ind, veget_max, cn_ind, height)
     !---------------------------------------------------------------------
     ! 0 declarations
@@ -38,4 +42,6 @@
     ! biomass (gC/(m**2 of ground))
     REAL(r_std),DIMENSION(npts,nvm,nparts),INTENT(in) :: biomass
+    ! woodmass of the individual, needed to calculate crownarea in lpj_crownarea
+    REAL(r_std),DIMENSION(npts,nvm),INTENT(in) :: woodmass_ind
     !-
     ! 0.2 modified fields
@@ -59,5 +65,5 @@
     ! wood mass of an individual
     !-
-    REAL(r_std),DIMENSION(npts) :: woodmass
+!!$    REAL(r_std),DIMENSION(npts) :: woodmass
     !-
     ! index
@@ -75,5 +81,5 @@
     ! 1.1 check if DGVM activated
     !-
-    IF (.NOT.control%ok_dgvm) THEN
+    IF (.NOT.control%ok_dgvm .AND. lpj_gap_const_mort) THEN
        STOP 'crown: not to be called with static vegetation.'
     ENDIF
@@ -81,5 +87,5 @@
     ! 1.2 initialize output to zero
     !-
-    cn_ind(:,:) = 0.0
+    cn_ind(:,:) = zero
     ! no convertion, just cop
     height_presc_12(1:nvm) = height_presc(1:nvm)
@@ -94,18 +100,24 @@
           IF (natural(j)) THEN
              !------ 2.1.1 natural
-             WHERE (PFTpresent(:,j) .AND.ind(:,j).GT.min_stomate)
-                !-------- 2.1.1.1 calculate individual wood mass
-                woodmass(:) = &
-                     &         (biomass(:,j,isapabove)+biomass(:,j,isapbelow) &
-                     &         +biomass(:,j,iheartabove)+biomass(:,j,iheartbelow))/ind(:,j)
+             !WHERE (PFTpresent(:,j) .AND.ind(:,j).GT.min_stomate)
+             WHERE (PFTpresent(:,j) .AND.woodmass_ind(:,j).GT.min_stomate)
+!!$SZ note that woodmass_ind needs to be defined on the individual, hence
+!!$ biomass*veget_max/ind, not as stated here, correction MERGE
+!!$!-------- 2.1.1.1 calculate individual wood mass
+!!$          woodmass(:) = &
+!!$ &         (biomass(:,j,isapabove)+biomass(:,j,isapbelow) &
+!!$ &         +biomass(:,j,iheartabove)+biomass(:,j,iheartbelow))/ind(:,j)
                 !-------- 2.1.1.2 stem diameter (pipe model)
-                dia(:) = (woodmass(:)/(pipe_density*pi/4.*pipe_tune2)) &
+!!$          dia(:) = (woodmass(:)/(pipe_density*pi/4.*pipe_tune2)) &
+                dia(:) = (woodmass_ind(:,j)/(pipe_density*pi/4.*pipe_tune2)) &
                      &                **(1./(2.+pipe_tune3))
                 !-------- 2.1.1.3 height
                 height(:,j) = pipe_tune2*(dia(:)**pipe_tune3)
-                WHERE (height(:,j) > height_presc_12(j))
-                   dia(:) = (height_presc_12(j)/pipe_tune2)**(1./pipe_tune3)
-                   height(:,j) = height_presc_12(j)
-                ENDWHERE
+!!$SZ: The constraint on height has nothing to do with LPJ (for that purpose there's dia_max
+!!$ cannot see why this is necessary - it also blurrs the output, hence I leave it commented
+!!$                WHERE (height(:,j) > height_presc_12(j))
+!!$                   dia(:) = (height_presc_12(j)/pipe_tune2)**(1./pipe_tune3)
+!!$                   height(:,j) = height_presc_12(j)
+!!$                ENDWHERE
                 !-------- 2.1.1.4 crown area: for large truncs, crown area cannot
                 !--------         exceed a certain value, prescribed through maxdia.
@@ -122,5 +134,5 @@
           WHERE (PFTpresent(:,j))
              !------ 2.2.1 an "individual" is 1 m**2 of grass
-             cn_ind(:,j) = 1.
+             cn_ind(:,j) = un
           ENDWHERE
        ENDIF
@@ -129,9 +141,13 @@
        !       ind and cn_ind are 0 if not present
        !---
-       !SZ isn't this physically inconsistent with the assumptions of sechiba??
-       ! the actual LPJ formulation calculates fpc from maximum LAI, and fpar from actual LAI=veget
-       IF (natural(j).AND.control%ok_dgvm) THEN
-          veget_max(:,j) = ind(:,j) * cn_ind(:,j)
-       ENDIF
+!!$SZ: since now all state variables are defined on veget_max it is very
+!!$ dangerous to change this several times in stomate_lpj, as then GPP, turnover and allocated 
+!!$ biomass are not defined on the same space! Hence, veget_max is now kept constant
+!!$ and updated at the end of stomate_lpj in lpj_cover.f90
+!!$ Eventually, this routine should only be called once at the beginning and the end of stomate_lpj
+!!$ or prefereably cn_ind made a saved state variable!
+!!$    IF (natural(j).AND.control%ok_dgvm) THEN
+!!$      veget_max(:,j) = ind(:,j) * cn_ind(:,j)
+!!$    ENDIF
     ENDDO
     !-------------------
